<template>
  <ObTable
    :columns="columns"
    :functional-panel="true"
    :is-functional-group="false"
    :is-functional-sort="false"
    :remote-opt="{
      method: fetchReports,
      contentKey: 'reports'
    }"
  >
    <template
      slot="tender-link"
      slot-scope="{ data }"
    >
      <a
        class="link-style"
        target="_blank"
        @click.prevent="openTender(data.item.tenderUuid)"
      >
        Смотреть тендер
      </a>
    </template>

    <div
      slot="download"
      slot-scope="{ data }"
      class="report-status"
    >
      <span
        v-if="data.item.status === 'IN_PROGRESS'"
        class="-gray-slate"
      >
        В процессе...
      </span>

      <a
        v-else
        target="_blank"
        class="report-link link-style"
        :href="data.item.url"
      >
        <i class="icon excel report-link__icon" /> Скачать
      </a>
    </div>

    <template
      slot="date"
      slot-scope="{ data }"
    >
      {{ moment(data.item.createdAt).format('DD.MM.YYYY') }}

      <span class="-gray-slate">
        {{ moment(data.item.createdAt).format('HH:mm') }}
      </span>
    </template>
  </ObTable>
</template>

<script>
  import api from '@/api'
  import moment from 'moment'
  import ObTable from 'common-components/src/obComponents/obTable'

  export default {
    name: "tenders-tab-reports",
    components: {
      ObTable
    },
    computed: {
      columns () {
        return [
          {
            title: 'Наименование отчета',
            key: 'name'
          },
          {
            title: 'Смотреть тендер',
            headerHtml: () => '',
            slotName: 'tender-link',
            exactWidth: '175px'
          },
          {
            title: 'Готовность отчета',
            key: 'download',
            slotName: 'download',
            sortDisable: true,
            exactWidth: '150px',
            headerHtml: () => 'Готовность<br>отчета'
          },
          {
            title: 'Дата заказа отчета',
            key: 'createdAt',
            slotName: 'date',
            exactWidth: '160px'
          }
        ]
      }
    },
    methods: {
      moment,
      async fetchReports ({ page, size, query, sort }) {
        const response = await api.tenders.getReports({ page, size, query, sort })

        return response
      },
      openTender (uuid) {
        window.open(this.$router.resolve({ path: `/tenders/${uuid}` }).href, '_blank')
      }
    }
  }
</script>

<style lang="scss" scoped>
  .report-status {
    display: flex;
    align-items: center;
  }

  .report-link {
    display: inline-flex;
    align-items: center;

    &__icon {
      font-size: 16px;
      margin-right: 6px;
    }
  }
</style>